#ifndef __Reg_ph__
#define __Reg_ph__

void RegBolClear (RegBol This);
void RegBolDump (RegBol This);
int RegBolExecute (RegBol This, char* text, int pos);
RegExp RegBolNew ();

void RegCharClear (RegChar This);
void RegCharDump (RegChar This);
int RegCharExecute (RegChar This, char* text, unsigned int pos);
RegExp RegCharNew (char c);

RegExp RegDotNew ();
void RegDotClear (RegDot This);
void RegDotDump (RegDot This);
int RegDotExecute (RegDot This, char* text, unsigned int pos);

void RegEolClear (RegEol This);
int RegEolExecute (RegEol This, char* text, unsigned int pos);
void RegEolDump (RegEol This);
RegExp RegEolNew ();

RegExp RegExpNew (char* text);
void RegExpDelete (RegExp This);
void RegExpSetNext (RegExp This, RegExp exp);
int RegExpMatch (RegExp This, char* text);
void RegExpDump (RegExp This);
int RegExpIndex ();
int RegExpLength ();

void RegListClear (RegList This);
void RegListDump (RegList This);
int RegListExecute (RegList This, char* text, int pos);
RegExp RegListNew (RegExp exp);

void RegOrClear (RegOr This);
void RegOrDump (RegOr This);
int RegOrExecute (RegOr This, char* text, int pos);
RegExp RegOrNew (RegExp exp1, RegExp exp2);

void RegSetClear (RegSet This);
void RegSetAddChar (RegSet This, char c);
void RegSetDump (RegSet This);
int RegSetExecute (RegSet This, char* text, unsigned int pos);
RegExp RegSetNew (RegSetMode mode);

void RegUnaryClear (RegUnary This);
void RegUnaryDump (RegUnary This);
int RegUnaryExecute (RegUnary This, char* text, int pos);
RegExp RegUnaryNew (RegUnaryOp op, RegExp exp);

#endif /* __Reg_ph__ */
